searchNodes=[{"doc":"This module provides high-level Fluvio interface for cluster functionalities.","ref":"Fluvio.html","title":"Fluvio","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fluvio.html#child_spec/1","title":"Fluvio.child_spec/1","type":"function"},{"doc":"Gets the platform version of the connected cluster.","ref":"Fluvio.html#platform_version/1","title":"Fluvio.platform_version/1","type":"function"},{"doc":"Starts a GenServer process linked to the current process connected to Fluvio cluster.","ref":"Fluvio.html#start_link/2","title":"Fluvio.start_link/2","type":"function"},{"doc":"Fluvio Admin cluster functionalities. This module is backed by a GenServer.","ref":"Fluvio.Admin.html","title":"Fluvio.Admin","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fluvio.Admin.html#child_spec/1","title":"Fluvio.Admin.child_spec/1","type":"function"},{"doc":"Creates a topic.","ref":"Fluvio.Admin.html#create_topic/3","title":"Fluvio.Admin.create_topic/3","type":"function"},{"doc":"Deletes a topic.","ref":"Fluvio.Admin.html#delete_topic/2","title":"Fluvio.Admin.delete_topic/2","type":"function"},{"doc":"Starts a GenServer process linked to the current process connected to Fluvio cluster.","ref":"Fluvio.Admin.html#start_link/2","title":"Fluvio.Admin.start_link/2","type":"function"},{"doc":"PartitionConsumer functionalities. This module is backed by a GenServer.","ref":"Fluvio.Consumer.html","title":"Fluvio.Consumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fluvio.Consumer.html#child_spec/1","title":"Fluvio.Consumer.child_spec/1","type":"function"},{"doc":"Starts a Fluvio PartitionConsumer GenServer process linked to the current process.","ref":"Fluvio.Consumer.html#start_link/3","title":"Fluvio.Consumer.start_link/3","type":"function"},{"doc":"Invokes the given func/1 for each result in the stream continuously.","ref":"Fluvio.Consumer.html#stream_each/3","title":"Fluvio.Consumer.stream_each/3","type":"function"},{"doc":"Gets next record of the stream. If you want to traverse continuously the stream, you can call stream_each/3 , or alternatively recursively call this function.","ref":"Fluvio.Consumer.html#stream_next/2","title":"Fluvio.Consumer.stream_next/2","type":"function"},{"doc":"Unfolds the infinite stream lazily. timeout_iter_ms is a low-level iteration timeout in ms to avoid blocking the DirtyIO Rust NIF for too long.","ref":"Fluvio.Consumer.html#stream_unfold/2","title":"Fluvio.Consumer.stream_unfold/2","type":"function"},{"doc":"TopicProducer functionalities. This module is backed by a GenServer.","ref":"Fluvio.Producer.html","title":"Fluvio.Producer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fluvio.Producer.html#child_spec/1","title":"Fluvio.Producer.child_spec/1","type":"function"},{"doc":"Flushes all the queued records in the producer batches.","ref":"Fluvio.Producer.html#flush/1","title":"Fluvio.Producer.flush/1","type":"function"},{"doc":"Sends a list of string values or tuple key values to this producer's topic. flush/1 should be called to flush the records in the producer batches.","ref":"Fluvio.Producer.html#send/2","title":"Fluvio.Producer.send/2","type":"function"},{"doc":"Sends a key value record to this producer's topic. flush/1 should be be called to flush the records in the producer batches.","ref":"Fluvio.Producer.html#send/3","title":"Fluvio.Producer.send/3","type":"function"},{"doc":"Starts a Fluvio TopicProducer GenServer process linked to the current process. Config example: %{topic: &quot;some_topic&quot;, options: %{}}","ref":"Fluvio.Producer.html#start_link/3","title":"Fluvio.Producer.start_link/3","type":"function"},{"doc":"fluvio-ex 💧Elixir client for Fluvio streaming platform Docs","ref":"readme.html","title":"README","type":"extras"},{"doc":"You can add fluvio to your list of dependencies in mix.exs : def deps do [ { :fluvio , &quot;~&gt; 0.2&quot; } ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"The following Fluvio Rust interfaces are supported on Elixir: Rust Elixir fluvio::PartitionConsumer Fluvio.Consumer fluvio::TopicProducer Fluvio.Producer fluvio::FluvioAdmin Fluvio.Admin Each Elixir module tends to provide equivalent functionalities that fluvio crate exposes, although Elixir-oriented to be well integrated with Elixir ecosystem and OTP. fluvio::FluvioAdmin is minimally supported since provisioning cluster resources is typically done upfront and not at the application level, but for experimentation it's useful to have Fluvio.Admin .","ref":"readme.html#features","title":"README - Features","type":"extras"},{"doc":"Consumer This snippet illustrates a Fluvio.Consumer connected to a &quot;lobby&quot; topic and using an optional SmartModule filter. Initially, it lazily unfolds the infinite stream, taking 4 records and chunking every 2. Finally, it keeps consuming it. alias Fluvio.Consumer { :ok , pid } = Consumer . start_link ( %{ topic : &quot;lobby&quot; , offset : [ from_beginning : 0 ] , smartmodule_path : &quot;./examples/wasm/map_reverse.wasm&quot; } ) Consumer . stream_unfold ( pid ) |&gt; Stream . take ( 4 ) |&gt; Stream . chunk_every ( 2 ) |&gt; Enum . to_list ( ) |&gt; IO . inspect ( ) Consumer . stream_each ( pid , fn result -&gt; case result do { :ok , record } -&gt; IO . inspect ( record ) { :error , msg } -&gt; IO . inspect ( &quot;Error: \#{ msg } &quot; ) end end ) MIX_ENV=prod mix run examples/consumer_smartmodule.exs Producer This snippet illustrates a Fluvio.Producer connected to a &quot;lobby&quot; topic. Initially, a string value &quot;hello&quot; is sent and flushed synchronously. Also, 20 values are sent asynchronously and flushed in chunks of 10. alias Fluvio.Producer { :ok , pid } = Producer . start_link ( %{ topic : &quot;lobby&quot; } ) { :ok , _ } = Producer . send ( pid , &quot;hello&quot; ) { :ok , _ } = Producer . flush ( pid ) [ ] = 1 .. 20 |&gt; Stream . chunk_every ( 10 ) |&gt; Stream . flat_map ( fn chunk -&gt; [ chunk |&gt; Enum . map ( fn value -&gt; Task . async ( fn -&gt; { Producer . send ( pid , to_string ( value ) ) , value } end ) end ) |&gt; Task . await_many ( ) |&gt; Enum . filter ( &amp; match? ( { { :error , _msg } , _value } , &amp;1 ) ) , [ { Producer . flush ( pid ) , :flush } ] |&gt; Enum . filter ( &amp; match? ( { { :error , _msg } , _value } , &amp;1 ) ) ] end ) |&gt; Stream . concat ( ) |&gt; Enum . to_list ( ) MIX_ENV=prod mix run examples/producer.exs Supervised Producer and Consumer This example demonstrates a ping pong application that uses two pairs of a Fluvio.Producer and Fluvio.Consumer , which have been linked to an Elixir Supervisor ( Task.Supervisor ) to provide process fault-tolerance inside your app. You could also strategically restart and init with a different Fluvio.Consumer offset. alias Fluvio.Producer alias Fluvio.Consumer alias Fluvio.Record defmodule App do def start ( topic_1 \\\\ &quot;ping&quot; , topic_2 \\\\ &quot;pong&quot; , initial_value \\\\ &quot;1&quot; ) do children = [ { Task.Supervisor , name : TaskSup } ] { :ok , sup_pid } = Supervisor . start_link ( children , strategy : :one_for_one ) { :ok , pid_one } = Task.Supervisor . start_child ( TaskSup , fn -&gt; { :ok , p1_pid } = Producer . start_link ( %{ topic : topic_1 } ) { :ok , c2_pid } = Consumer . start_link ( %{ topic : topic_2 , offset : [ from_end : 0 ] } ) IO . inspect ( &quot;Bootstrapping &#39; \#{ topic_1 } &#39; by sending &#39; \#{ initial_value } &#39;&quot; ) { :ok , _ } = Producer . send ( p1_pid , initial_value ) { :ok , _ } = Producer . flush ( p1_pid ) App.PingPong . keep_consuming ( c2_pid , p1_pid ) end , restart : :permanent ) { :ok , pid_two } = Task.Supervisor . start_child ( TaskSup , fn -&gt; { :ok , p2_pid } = Producer . start_link ( %{ topic : topic_2 } ) { :ok , c1_pid } = Consumer . start_link ( %{ topic : topic_1 , offset : [ from_end : 0 ] } ) App.PingPong . keep_consuming ( c1_pid , p2_pid ) end , restart : :permanent ) { sup_pid , pid_one , pid_two } end defmodule PingPong do defp produce ( p_pid , value ) do IO . inspect ( &quot;Producing value: &#39; \#{ value } &#39;&quot; ) { :ok , _ } = Producer . send ( p_pid , value ) { :ok , _ } = Producer . flush ( p_pid ) end defp do_consume ( { :ok , % Record { value : &quot;4&quot; } } , _c_pid , _p_pid ) do raise ( &quot;simulating an unrecoverable error&quot; ) end defp do_consume ( { :ok , record } , _c_pid , p_pid ) do IO . inspect ( &quot;Consumed value: &#39; \#{ record . value } &#39;&quot; ) produce ( p_pid , to_string ( String . to_integer ( record . value ) + 1 ) ) end defp do_consume ( { :error , _msg } , c_pid , _p_pid ) , do : Process . exit ( c_pid , :kill ) defp do_consume ( { :stop_next , _ } , _c_pid , _p_pid ) , do : nil def keep_consuming ( c_pid , p_pid , min_freq_ms \\\\ 1000 ) do Consumer . stream_each ( c_pid , fn result -&gt; Process . sleep ( min_freq_ms ) do_consume ( result , c_pid , p_pid ) end ) end end end If you were to run this example, you'd see that once the pairs of producer and consumer start, the initial value &quot;1&quot; is sent, and each pair will keep incrementing the value and sending it. Once the value &quot;4&quot; is reached, the ping consumer simulates an unrecoverable error, which will crash this process and the supervisor will restart it: MIX_ENV=prod iex -S mix iex(1)&gt; c &quot;examples/ping_pong.exs&quot; [App, App.PingPong] iex(2)&gt; App.start() {#PID&lt;0.220.0&gt;, #PID&lt;0.222.0&gt;, #PID&lt;0.223.0&gt;} &quot;Bootstrapping &#39;ping&#39; by sending &#39;1&#39;&quot; &quot;Consumed value: &#39;1&#39;&quot; &quot;Producing value: &#39;2&#39;&quot; &quot;Consumed value: &#39;2&#39;&quot; &quot;Producing value: &#39;3&#39;&quot; &quot;Consumed value: &#39;3&#39;&quot; &quot;Producing value: &#39;4&#39;&quot; iex(3)&gt; 01:31:46.911 [error] Task #PID&lt;0.222.0&gt; started from #PID&lt;0.207.0&gt; terminating ** (RuntimeError) simulating an unrecoverable error examples/ping_pong.exs:46: App.PingPong.do_consume/3 (fluvio 0.2.0) lib/fluvio/consumer.ex:172: Fluvio.Consumer.stream_each/3 (elixir 1.14.0) lib/task/supervised.ex:89: Task.Supervised.invoke_mfa/2 (stdlib 4.1) proc_lib.erl:240: :proc_lib.init_p_do_apply/3 Function: #Function&lt;0.131083353/0 in App.start/3&gt; Args: [] &quot;Bootstrapping &#39;ping&#39; by sending &#39;1&#39;&quot; &quot;Consumed value: &#39;1&#39;&quot; &quot;Producing value: &#39;2&#39;&quot; &quot;Consumed value: &#39;2&#39;&quot;","ref":"readme.html#examples","title":"README - Examples","type":"extras"}]